class X {                           
    private int regularIntEnclosing;                              //(A)
    private static int staticIntEnclosing = 300;                  //(B)

    public class Y{                        
        private int m;
        private int n;
        public Y() { 
            m = regularIntEnclosing;                              //(C)
            n = staticIntEnclosing;                               //(D)
        }
    }

    public X( int n ) { regularIntEnclosing = n; }                //(E) 
}

class Test {
    public static void main( String[] args ) {
        X x = new X( 100 );                                       //(F)
        // X.Y y = new X.Y();             // error
        X.Y y = x.new Y();                // ok                   //(G)
    }
}