interface Drawable {

    class Color {
        private int red;
        private int green;
        private int blue;
        public Color( int r, int g, int b ) {
            red = r;
            green = g;
            blue = b;
        }
    }

    void setColor( Color c );
    void draw();
}

class Rectangle implements Drawable {
    private Color color;  // Color made available by the interface
    private int width;
    private int height;
 
    public Rectangle( int w, int h ) {
        width = w;
        height = h;
    }

    public void setColor( Color c ) { color = c; }

    public void draw() {
        System.out.println( "Invoke code for drawing a rectangle" );
    }

    public static void main( String[] args ) {
        Color col = new Color( 120, 134, 200 );
        Rectangle rect = new Rectangle( 23, 34 );
        rect.setColor( col );
        rect.draw();
    }
}